Subject: Re: [netmod] yang-03, 8.3.x, stepping on NETCONF turf

From: David Partain <[email-masked]>
Date: Mon, 2 Mar 2009 13:52:26 +0100

On Thursday 12 February 2009 21.18.34 Andy Bierman wrote:
> Martin Bjorklund wrote:
> > Andy Bierman <[email-masked]> wrote:
> >> ....
> >>
> >>> So you are wanting to allow any garbage from the client, as long
> >>> as the server is allowed to give errors?   I don't see the point.
> >>> We want to give both the client and server strong constraints on
> >>> what they can send and what they will receive in order to increase
> >>> interoperability and help folks do the right think.
> >>
> >> The server is 'required' to give errors, not 'allowed' to give errors.
> >> It seems strange to mandate with MUST-type normative text
> >> that the manager MUST NOT send certain requests that
> >> the agent will answer with an 'unknown-element' error.
> >
> > I agree with you.  What if rephrase the text we're discussing so that
> > it instead specifies which error the server MUST send?
> >
> > For example, instead of:
> >
> >   Leaf data values MUST match the type constraints for those leafs,
> >   including those defined in the type's range, length, and pattern
> >   properties.
> >
> > we could say:
> >
> >   If a leaf data value does not match the type constraints for the
> >   leaf, including those defined in the type's range, length, and
> >   pattern properties, the server MUST reply with an 'invalid-value'
> >   error-tag in the rpc-error.
>
> This is excellent.
> The necessary and sufficient text in the YANG document
> should be limited to how (and when) a NETCONF agent enforces the
> behavior in particular YANG constructs.
>
> > I'm not sure if the original text also tried to put requirements on
> > data sent by the server as replies to e.g. <get> requests.
>
> The YANG draft (e.g., canonical XML representation) certainly
> puts requirements on what an agent can send.  That is OK.

Hi,

After reading through this thread (again), it appears to me that the 
protagonists in the discussion are happy (or at least silent).  Seems to me 
we can put this one to bed.

David

---

From: Martin Bjorklund <[email-masked]>
Date: Mon, 02 Mar 2009 14:09:44 +0100 (CET)

> we can put this one to bed.

I have rewritten this list according to what I proposed, and what Andy
said was fine, and noone objected to.  I hope that was what you meant?

/martin

---

From: David Partain <[email-masked]>
Date: Mon, 2 Mar 2009 14:39:02 +0100

Hi,

> > protagonists in the discussion are happy (or at least silent).  Seems to
> > me we can put this one to bed.
>

Yep, that's what I meant.  There was other discussion (particularly between 
Phil and Andy) that didn't result in textual changes and I simply wanted to 
make sure that weren't any expected changes _other_ than what you put in 
http://www.ietf.org/mail-archive/web/netmod/current/msg02098.html 

Cheers,

David